import "classes/*.pp"
import "common/*.pp"
import "/etc/puppet/modules/module-svn/manifests/*.pp"

# Create "/tmp/testfile" if it doesn't exist.
class test_class {
    file { "/tmp/testfile":
       ensure => present,
       mode   => 644,
       owner  => root,
       group  => root
    }
}

# tell puppet on which client to run the class
#node walsh {
#    include test_class
#}
node walsh {
    include test_class
    include matrix::cronapt
    include estacion-de-trabajo

    ltsp::buildclient { dist:
        mirror => "http://debproxy:3142/ar.archive.ubuntu.com/ubuntu",
        securitymirror => "http://debproxy:3142/security.ubuntu.com"
    }

    include ltsp::tftpdhpa::activate

    include matrix::ldapauthclient

    svn::checkout { dist:
       repository => "https://svn.redcta.org.ar/proyectos/redcta/trunk/gnome-theme-xp",
#       svnparms = "--someparameter=AAAA --other parameter",
       local_path => "/dist",
       local_name => "gnome-theme-xp" 
#       user => "puppet",
#       password => "mypassword"

# ln -s /dist/gnome-theme-xp/files/GnomeXP /usr/share/icons
# ln -s /dist/gnome-theme-xp/files/XPLuna /usr/share/themes
   }

}

node zara  {
    include test_class
}

